libzypp 17.37.10

zypp::media::MediaCurl2 Class Reference

Implementation class for FTP, HTTP and HTTPS MediaHandler. More...

`#include <zypp/media/MediaCurl2.h>`

Inheritance diagram for zypp::media::MediaCurl2:

## Classes
struct | RequestData

## Public Types
enum | RequestOption { OPTION_NONE = 0x0 , OPTION_NO_REPORT_START = 0x1 }
Public Types inherited from zypp::media::MediaHandler
using | Ptr = shared_ptr<MediaHandler>
using | constPtr = shared_ptr<const MediaHandler>

## Public Member Functions
| ZYPP_DECLARE_FLAGS (RequestOptions, RequestOption)
| MediaCurl2 (const MirroredOrigin origin_r, const Pathname &attach_point_hint_r)
| ~MediaCurl2 () override
Public Member Functions inherited from zypp::media::MediaNetworkCommonHandler
| MediaNetworkCommonHandler (const MirroredOrigin &origin_r, const Pathname &attach_point_r, const Pathname &urlpath_below_attachpoint_r, const bool does_download_r)
void | getFile (const OnMediaLocation &file) const override
| Call concrete handler to provide file below attach point.
void | getDir (const Pathname &dirname, bool recurse_r) const override
| Call concrete handler to provide directory content (not recursive!) below attach point.
void | getDirInfo (std::list< std::string > &retlist, const Pathname &dirname, bool dots=true) const override
| Call concrete handler to provide a content list of directory on media via retlist.
void | getDirInfo (filesystem::DirContent &retlist, const Pathname &dirname, bool dots=true) const override
| Basically the same as getDirInfo above.
Public Member Functions inherited from zypp::media::MediaHandler
bool | dependsOnParent (MediaAccessId parentId, bool exactIdMatch)
| Check if the current media handler depends on an another handler specified by media access id.
bool | dependsOnParent ()
void | resetParentId ()
| Called in case, where the media manager takes over the destruction of the parent id (e.g.
Pathname | attachPoint () const
| Return the currently used attach point.
void | setAttachPoint (const Pathname &path, bool temp)
| Set a new attach point.
void | setAttachPoint (const AttachPointRef &ref)
| Set a (shared) attach point.
AttachPoint | attachPointHint () const
| Get the actual attach point hint.
void | attachPointHint (const Pathname &path, bool temp)
| Set the attach point hint as specified by the user.
Pathname | createAttachPoint () const
| Try to create a default / temporary attach point.
Pathname | createAttachPoint (const Pathname &attach_root) const
| Try to create a temporary attach point in specified root.
void | removeAttachPoint ()
| Remove unused attach point.
bool | isUseableAttachPoint (const Pathname &path, bool mtab=true) const
| Ask media manager, if the specified path is already used as attach point or if there are another attach points bellow of it.
std::string | mediaSourceName () const
| Get the media source name or an empty string.
void | setMediaSource (const MediaSourceRef &ref)
| Set new media source reference.
AttachedMedia | findAttachedMedia (const MediaSourceRef &media) const
| Ask the media manager if specified media source is already attached.
AttachedMedia | attachedMedia () const
| Returns the attached media.
bool | isSharedMedia () const
| Returns a hint if the media is shared or not.
bool | checkAttached (bool matchMountFs) const
| Check actual mediaSource attachment against the current mount table of the system.
void | forceRelaseAllMedia (bool matchMountFs)
| Call to this function will try to release all media matching the currenlty attached media source, that it is able to find in the mount table.
void | forceRelaseAllMedia (const MediaSourceRef &ref, bool matchMountFs)
| MediaHandler (MirroredOrigin origin_r, const Pathname &attach_point_r, Pathname urlpath_below_attachpoint_r, const bool does_download_r)
| If the concrete media handler provides a nonempty attach_point, it must be an existing directory.
virtual | ~MediaHandler ()
| Contolling MediaAccess takes care, that attached media is released prior to deleting this.
bool | downloads () const
| Hint if files are downloaded or not.
std::string | protocol () const
| Protocol hint for MediaAccess.
Url | url () const
| Primary Url used.
OriginEndpoint | originEndpoint () const
| Primary OriginEndpoint used.
void | attach (bool next)
| Use concrete handler to attach the media.
virtual bool | isAttached () const
| True if media is attached.
Pathname | localRoot () const
| Return the local directory that corresponds to medias url, no matter if media isAttached or not.
Pathname | localPath (const Pathname &pathname) const
| Files provided will be available at 'localPath(filename)'.
void | disconnect ()
| Use concrete handler to isconnect media.
void | release (const std::string &ejectDev="")
| Use concrete handler to release the media.
void | provideFile (const OnMediaLocation &file) const
| Use concrete handler to provide file denoted by path below 'localRoot'.
void | provideFileCopy (const OnMediaLocation &srcFile, const Pathname &targetFilename) const
| Call concrete handler to provide a copy of a file under a different place in the file system (usually not under attach point) as a copy.
void | provideDir (const Pathname &dirname) const
| Use concrete handler to provide directory denoted by path below 'localRoot' (not recursive!).
void | provideDirTree (const Pathname &dirname) const
| Use concrete handler to provide directory tree denoted by path below 'localRoot' (recursive!
void | releaseFile (const Pathname &filename) const
| Remove filename below localRoot IFF handler downloads files to the local filesystem.
void | releaseDir (const Pathname &dirname) const
| Remove directory tree below localRoot IFF handler downloads files to the local filesystem.
void | releasePath (const Pathname &pathname) const
| Remove pathname below localRoot IFF handler downloads files to the local filesystem.
void | dirInfo (std::list< std::string > &retlist, const Pathname &dirname, bool dots=true) const
| Return content of directory on media via retlist.
void | dirInfo (filesystem::DirContent &retlist, const Pathname &dirname, bool dots=true) const
| Basically the same as dirInfo above.
bool | doesFileExist (const Pathname &filename) const
| check if a file exists
virtual bool | hasMoreDevices ()
| Check if the media has one more device available for attach(true).
virtual void | getDetectedDevices (std::vector< std::string > &devices, unsigned int &index) const
| Fill in a vector of detected ejectable devices and the index of the currently attached device within the vector.
virtual void | precacheFiles (const std::vector< OnMediaLocation > &files)
| Tries to fetch the given files and precaches them.

## Protected Member Functions
void | releaseFrom (const std::string &ejectDev) override
| Call concrete handler to release the media.
bool | getDoesFileExist (const Pathname &filename) const override
| Repeatedly calls doGetDoesFileExist() until it successfully returns, fails unexpectedly, or user cancels the operation.
void | disconnectFrom () override
void | getFileCopy (const OnMediaLocation &srcFile, const Pathname &targetFilename) const override
void | checkProtocol (const Url &url) const override
| check the url is supported by the curl library
Protected Member Functions inherited from zypp::media::MediaNetworkCommonHandler
void | attachTo (bool next) override
| Call concrete handler to attach the media.
bool | checkAttachPoint (const Pathname &apoint) const override
| Verify if the specified directory as attach point (root) as requires by the particular media handler implementation.
Url | clearQueryString (const Url &url) const
Url | getFileUrl (int mirrorIdx, const Pathname &filename) const
| concatenate the attach url and the filename to a complete download url
void | setupTransferSettings ()
| initializes the curl easy handle with the data from the url
void | clearTransferSettings ()
bool | authenticate (const Url &url, TransferSettings &settings, const std::string &availAuthTypes, bool firstTry)
std::vector< unsigned > | mirrorOrder (const OnMediaLocation &loc) const
Protected Member Functions inherited from zypp::media::MediaHandler
virtual void | forceEject (const std::string &device)
| Call concrete handler to physically eject the media (i.e.
void | getDirectoryYast (std::list< std::string > &retlist, const Pathname &dirname, bool dots=true) const
| Retrieve and if available scan dirname/directory.yast.
void | getDirectoryYast (filesystem::DirContent &retlist, const Pathname &dirname, bool dots=true) const
| Retrieve and if available scan dirname/directory.yast.

## Private Member Functions
void | executeRequest (RequestData &reqData, callback::SendReport< DownloadProgressReport > *report=nullptr)
bool | tryZchunk (RequestData &reqData, const OnMediaLocation &srcFile, const Pathname &target, callback::SendReport< DownloadProgressReport > &report)

## Private Attributes
internal::MediaNetworkRequestExecutorRef | _executor

## Additional Inherited Members
Static Public Member Functions inherited from zypp::media::MediaNetworkCommonHandler
static zypp::Url | findGeoIPRedirect (const zypp::Url &url)
| Rewrites the baseURL to the geoIP target if one is found in the metadata cache, otherwise simply returns the url again.
static bool | authenticate (const Url &url, CredentialManager &cm, TransferSettings &settings, const std::string &availAuthTypes, bool firstTry)
static const char * | anonymousIdHeader ()
static const char * | distributionFlavorHeader ()
static const char * | agentString ()
template<typename Excpt>
static bool | canTryNextMirror (const Excpt &excpt_r)
Static Public Member Functions inherited from zypp::media::MediaHandler
static bool | setAttachPrefix (const Pathname &attach_prefix)
static std::string | getRealPath (const std::string &path)
static Pathname | getRealPath (const Pathname &path)
static bool | checkAttachPoint (const Pathname &apoint, bool empty_dir, bool writeable)
| Verify if the specified directory as attach point (root) using requested checks.
Static Public Attributes inherited from zypp::media::MediaNetworkCommonHandler
static constexpr std::string_view | MIRR_SETTINGS_KEY = "_zypp_transfersettings"
Protected Attributes inherited from zypp::media::MediaNetworkCommonHandler
std::vector< Url > | _redirTargets
Protected Attributes inherited from zypp::media::MediaHandler
MirroredOrigin | _origin
| Contains the authority URL and mirrors.
MediaAccessId | _parentId
| Access Id of media handler we depend on.

## Detailed Description

Implementation class for FTP, HTTP and HTTPS MediaHandler.

See also
  MediaHandler

Definition at line 43 of file MediaCurl2.h.

## Member Enumeration Documentation

## ◆ RequestOption

enum zypp::media::MediaCurl2::RequestOption

Enumerator
OPTION_NONE | Defaults.
OPTION_NO_REPORT_START | do not send a start ProgressReport

Definition at line 46 of file MediaCurl2.h.

## Constructor & Destructor Documentation

## ◆ MediaCurl2()

zypp::media::MediaCurl2::MediaCurl2 | ( | const MirroredOrigin | origin_r,
|  | const Pathname & | attach_point_hint_r )

Definition at line 68 of file MediaCurl2.cc.

## ◆ ~MediaCurl2()

zypp::media::MediaCurl2::~MediaCurl2 | ( |  | ) |
| inline override

Definition at line 83 of file MediaCurl2.h.

## Member Function Documentation

## ◆ ZYPP_DECLARE_FLAGS()

zypp::media::MediaCurl2::ZYPP_DECLARE_FLAGS | ( | RequestOptions | ,
|  | RequestOption | )

## ◆ releaseFrom()

void zypp::media::MediaCurl2::releaseFrom | ( | const std::string & | ejectDev | ) |
| override protected virtual

Call concrete handler to release the media.

If eject is true, and the media is used in one handler instance only, physically eject the media (i.e. CD-ROM).

Asserted that media is attached.

Parameters

  ejectDev | Device to eject. None if empty.

Exceptions

  MediaException |

Implements zypp::media::MediaHandler.

Definition at line 120 of file MediaCurl2.cc.

## ◆ getDoesFileExist()

bool zypp::media::MediaCurl2::getDoesFileExist | ( | const Pathname & | filename | ) | const
| override protected virtual

Repeatedly calls doGetDoesFileExist() until it successfully returns, fails unexpectedly, or user cancels the operation.

This is used to handle authentication or similar retry scenarios on media level.

Implements zypp::media::MediaHandler.

Definition at line 274 of file MediaCurl2.cc.

## ◆ disconnectFrom()

void zypp::media::MediaCurl2::disconnectFrom | ( |  | ) |
| override protected virtual

Exceptions

  MediaException |

Reimplemented from zypp::media::MediaHandler.

Definition at line 112 of file MediaCurl2.cc.

## ◆ getFileCopy()

void zypp::media::MediaCurl2::getFileCopy | ( | const OnMediaLocation & | srcFile,
|  | const Pathname & | targetFilename ) const
| override protected virtual

Exceptions

  MediaException |

Reimplemented from zypp::media::MediaHandler.

Definition at line 127 of file MediaCurl2.cc.

## ◆ checkProtocol()

void zypp::media::MediaCurl2::checkProtocol | ( | const Url & | url | ) | const
| override protected virtual

check the url is supported by the curl library

Exceptions

  MediaBadUrlException | if there is a problem

Implements zypp::media::MediaNetworkCommonHandler.

Definition at line 101 of file MediaCurl2.cc.

## ◆ executeRequest()

void zypp::media::MediaCurl2::executeRequest | ( | MediaCurl2::RequestData & | reqData,
|  | callback::SendReport< DownloadProgressReport > * | report = nullptr )
| private

Definition at line 409 of file MediaCurl2.cc.

## ◆ tryZchunk()

bool zypp::media::MediaCurl2::tryZchunk | ( | RequestData & | reqData,
|  | const OnMediaLocation & | srcFile,
|  | const Pathname & | target,
|  | callback::SendReport< DownloadProgressReport > & | report )
| private

Definition at line 339 of file MediaCurl2.cc.

## Member Data Documentation

## ◆ _executor

internal::MediaNetworkRequestExecutorRef zypp::media::MediaCurl2::_executor
| private

Definition at line 102 of file MediaCurl2.h.

The documentation for this class was generated from the following files:

- zypp/media/MediaCurl2.h
- zypp/media/MediaCurl2.cc